# ![logo](imgs/r3_logo.png) [![Build Status](https://travis-ci.org/neonov/r3.svg?branch=master)](https://travis-ci.org/neonov/r3)

_Reusable. Declarative. Yours._

Everyone loves charts, so `r3` library was built. With [React](https://facebook.github.io/react/) and [D3](https://d3js.org/).

> D3 has excellent maths and abstraction on the data such as [d3-scale](https://github.com/d3/d3-scale) and [d3-array](https://github.com/d3/d3-array). React pretty use for components and DOM manipulation. We want to leverage React's highly efficient, declarative, and reusable components with D3's data utility functions. Also, once we create a chart component, we can reuse that chart with different data anywhere in our app.

### Using

```js
var r3 = require('../path/to/r3');
// es6
import r3 from '../path/to/r3';
```

### Available Charts

```js
const BarChart = r3.BarChart
const ScatterPlot = r3.ScatterPlot
const LineChart = r3.LineChart
const HeatMap = r3.HeatMap
```

### Demo

![charts](imgs/charts.jpg)

[Try interactive demo](http://neonov.github.io/r3/demo1/)


### Docs

[Docs](./docs/docs.md)
