import React from 'react';
const ease = require('d3-ease');

class Bar extends React.Component {
  static defaultProps = {
    height: 0,
    width: 0,
    x: 0,
    y: 0
  };

  state = {
    height: 0,
    milliseconds: 0
  };

  shouldComponentUpdate() {
    return this.props.height !== this.state.height;
  }

  componentDidMount() {
    this.interval = requestAnimationFrame(this.tick.bind(this)) ;
  }

  componentWillUnmount() {
    cancelAnimationFrame(this.interval);
  }

  componentWillReceiveProps() {
    this.setState({
      height: this.props.height,
      milliseconds: 0
    });
  }

  getStyle() {
    return {
      transition: 'fill .3s ease-in-out'
    }
  }


  tick() {
    this.setState({
      milliseconds: this.state.milliseconds + 1000 / 160
    });
    requestAnimationFrame(this.tick.bind(this))
  }

  render() {

    this.state.height = this.state.height + (this.props.height - this.state.height) * ease.easePolyOut(Math.min(1, this.state.milliseconds / 1000), 2);
    const y = this.props.height - this.state.height + this.props.y;
    return (
      <g>
        <text fontSize="11"
          textAnchor="middle"
          x={this.props.x + this.props.width/2}
          y={y - 5}>{this.props.value}</text>
        <rect fill={this.props.fill}
          height={this.state.height}
          style={this.getStyle()}
          width={this.props.width}
          x={this.props.x}
          y={y}/>
      </g>
    );
  }
}

export default Bar