import React, {PropTypes, Component} from 'react';
import Bar from './bar';

class Bars extends Component {

  static propTypes = {
    data: PropTypes.array.isRequired,
    xScale: PropTypes.func.isRequired,
    yScale: PropTypes.func.isRequired
  };

  getStyle() {
    const { dx } = this.props;
    return {transform: `translate(${dx}px,0px)`}
  }

  render() {
    const { colorScale,
            data,
            height,
            xScale,
            yScale } = this.props;

    const bars = data.map((val, i) => {
      const color   = colorScale(val.value),
            _height = yScale(val.value),
            width   = xScale.bandwidth(),
            x       = xScale(val.name),
            y       = height - _height;

      return (
        <Bar fill={color}
          height={_height}
          key={i}
          value={val.value}
          width={width}
          x={x}
          y={y}/>
      )
    });

    return (
      <g style={this.getStyle()}>{bars}</g>
    );
  }
}

export default Bars;
