import React, {PropTypes, Component} from 'react';
import Box from './box'

class Boxes extends Component {

  static propTypes = {
    data: PropTypes.array.isRequired,
    xScale: PropTypes.func.isRequired,
    yScale: PropTypes.func.isRequired
  };


  getStyle() {
    const { dx } = this.props;
    return {transform: `translate(${dx}px,0px)`}
  }

  render() {
    const { background,
            colorScale,
            data,
            xScale,
            yScale,
            size } = this.props;

    const bars = data.map((val, i) => {
      const color = (val.z != null) ? colorScale(val.z) : background,
            y     = yScale(val.name),
            x     = xScale(val.x);

      return (
        <Box fill={color}
             height={size}
             width={size}
             key={i}
             value={val}
             x={x}
             y={y}/>
      )
    });

    return (
      <g style={this.getStyle()}>{bars}</g>
    );
  }
}

export default Boxes;
