import React, {Component, PropTypes} from 'react';

class Preloader extends Component {

  static propTypes = {
    className: PropTypes.string,
    height: PropTypes.number,
    show: PropTypes.bool,
    width: PropTypes.number
  };

  static defaultProps = {
    className: 'r3-preloader',
    height: 100,
    show: true,
    width: 100
  };

  getStyle() {
    return {
      position: 'absolute',
      top: 0,
      bottom: 0,
      left: 0,
      right: 0,
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'center'
    }
  }

  render() {

    const { className, show, width, height} = this.props;

    if (show) {
      return (
        <div style={this.getStyle()} className={className}>
          <svg width={width}
               height={height}
               viewBox="0 15 60 80" >
            <circle fill="red" stroke="none" cx="6" cy="50" r="6">
              <animateTransform
                attributeName="transform"
                dur="1s"
                type="translate"
                values="0 15 ; 0 -15; 0 15"
                repeatCount="indefinite"
                begin="0.1"/>
            </circle>
            <circle fill="red" stroke="none" cx="30" cy="50" r="6">
              <animateTransform
                attributeName="transform"
                dur="1s"
                type="translate"
                values="0 10 ; 0 -10; 0 10"
                repeatCount="indefinite"
                begin="0.2"/>
            </circle>
            <circle fill="red" stroke="none" cx="54" cy="50" r="6">
              <animateTransform
                attributeName="transform"
                dur="1s"
                type="translate"
                values="0 5 ; 0 -5; 0 5"
                repeatCount="indefinite"
                begin="0.3"/>
            </circle>
          </svg>
        </div>
      );
    } else {
      return null
    }

  }
}

export default Preloader